'use strict'

var s3 = require('./s3.js')
var readline = require('readline')
var config = require('./config.js')

function showHelp () {
  console.log(`
Usage: share get help             show this message
       share get <secretId>       update configure

`)
}

function question(ri, prompt) {
  return new Promise(function(resolve) { 
    ri.question(prompt,resolve)
  })
}

module.exports = function(options) {
  if (options.arguments.length !== 1 || options.arguments[0] ==='help' ) {
    showHelp()
    return
  }

  return s3.downloadSecret(options.arguments[0])
  .then(function(secret) {
    console.log('Secret type:', secret.datatype)
    switch (secret.datatype) {
      case 'string':
        console.log(secret.data.toString())
        break
      case undefined:
        console.log('No datatype')
        console.log(secret.data)
        break
      case 'file':
        console.log(secret.data.toString())
        break
      case 'config':
        console.log('Config received', JSON.stringify(JSON.parse(secret.data.toString()),null, 2))
        var ri = readline.createInterface({
          input: process.stdin,
          output: process.stdout
        })
        return question(ri, 'merge? [yes]')
        .then(function (answer) { 
          if (answer ==='' || answer.toUpperCase()==='YES')
            config.merge(JSON.parse(secret.data.toString()))
        })
        .then( () => ri.close())

        // prompt to merge or overwrite or ignore
        break
      default:
        console.log('Undefined secret type')
        console.log(secret.data)
        break
    }

    // perhaps remove s3 key?
  })
}