'use strict'
const validCommands = ['get', 'file', 'configure', 'string', 'config','help']

module.exports = function(args) {
  var params = args.slice(2)
  if (params.length === 0)
    printUsage()

  var withPosition = params.indexOf('with')
  var payloadStart
  var options = {}
  
  if ( validCommands.indexOf(params[0].toLowerCase()) !== -1 ) {
    options.command = params[0].toLowerCase()
    payloadStart = 1
  }
  else {
    options.command = 'dynamic'
    payloadStart = 0
  }
  

  if (options.command !== 'get' && options.command !== 'configure') {
    // get targets
    if (withPosition === -1)
      options.targets = [ params.pop() ]
    else {
      options.targets = params.splice(withPosition + 1)
      params.pop() // remove with
    }
  } 
  options.arguments = params.splice(payloadStart)
  
  return options
}

function printUsage() {
  console.log(`
Usage: share <command> params [with] target [target2]

       share get identifier
       share configure
       share config with target
       share string secret string goes here [with] target
       share string secret string goes here with target1 target2 target3
       share file filename [with] target
       share file filename with target target2 target3 ...
       share filename|string [with] target

If with is omitted the last argument is assumed to be the target.
If the command is omitted and the first argument is a valid file, that file is shared.
Otherwise the arguments before "with" are shared as a string
`
)
  process.exit()
}


// -- these take one parameter after file|string
// share file filename [with] @jshort
// share string 'string' [with] @jshort
// share string a long string with @jshort

// -- this takes one argument as filename if file not found it is a string, falls to next one
// share filename [with] @jshort
// -- this looks for with as end of string
// share a string with no delimiter with @jshort
// share a string jshort
// share a string @jshort

// -- non sharing options
// share get identifier
// share configure
