'use strict'

var s3 = require('./s3.js')
var slack = require('./slack.js')
var config = require('./config.js')

module.exports = function(options) {
  config.get()
  .then(function (config){
    // munge config
    delete config.userName
    return config
  })
  .then(function (config) {
    return s3.uploadSecret(JSON.stringify(config, null, 2), 'config').then(function (s3Key) {
      return slack.notifySecret('You have a configuration share.\nrun `share get ' + s3Key.key +'` to get it', options.targets)
    })
  })  
}

