'use strict'

var Promise = require('bluebird')
var slack = require('./slack.js')
var config = require('./config.js')

function makeBaseConfigCode(userName, bucket) {
  return new Buffer(JSON.stringify({s3Bucket: bucket, userName: userName})).toString('base64')
}
module.exports = function(options) {
  config.get()
  .then(function (config) {
    return Promise.map(options.targets, function (target) {

      return slack.notifySecret(
`Someone wants to share secrets with you.
0. Get your aws credentials on for ${config.awsAccountName}
1. \`npm install -g share\`
2. \`share configure ${makeBaseConfigCode(target, config.s3Bucket)} to add your base configuration\` 
3. If they also shared a config \`share get configsecretid\` to pull in the shared configuration`,
      [ target ], { usersOnly: true } )
    })
  })

}

